<?php
// +----------------------------------------------------------------------+
// | Anuko Time Tracker
// +----------------------------------------------------------------------+
// | Copyright (c) Anuko International Ltd. (http://www.anuko.com)
// +----------------------------------------------------------------------+
// | LIBERAL FREEWARE LICENSE: This source code document may be used
// | by anyone for any purpose, and freely redistributed alone or in
// | combination with other software, provided that the license is obeyed.
// |
// | There are only two ways to violate the license:
// |
// | 1. To redistribute this code in source form, with the copyright
// |    notice or license removed or altered. (Distributing in compiled
// |    forms without embedded copyright notices is permitted).
// |
// | 2. To redistribute modified versions of this code in *any* form
// |    that bears insufficient indications that the modifications are
// |    not the work of the original author(s).
// |
// | This license applies to this document only, not any other software
// | that it may be combined with.
// |
// +----------------------------------------------------------------------+
// | Contributors:
// | http://www.anuko.com/time_tracker/credits.htm
// +----------------------------------------------------------------------+

// Print UTF8 BOM first to identify encoding.
$bom = chr(239).chr(187).chr(191); // 0xEF 0xBB 0xBF in the beginning of the file is UTF8 BOM.
print $bom; // Without this Excel does not display UTF8 characters properly.

    if ($totals_only) {
    	$short_header = array();
    	foreach ($hkeys as $k=>$fn) {
    		if ($fn==$sort_key || $fn=='duration' || $fn=='cost') $short_header[] = $header[$k];
    	}
    	print join(",",$short_header)."\n";
    	
    	if (is_array($subtotals) && !isset($subtotals['common'])) {
	    	foreach ($subtotals as $v=>$sv) {
				$v = str_replace('"','""',$v);
				if ($v=='')	$v = '"'.$v.'"';
				$duration = $sv['time'];
			    if(defined('EXPORT_DECIMAL_DURATION') && isTrue(EXPORT_DECIMAL_DURATION))
			      $duration = time_to_decimal($duration);
			    print $v.",".$duration;
			    if ($includeCost)
				  print ",\"".$sv['cost']."\"";
				print "\n";
	    	}
    	}
    
    } else {
    	print join(",",$header)."\n";
    	$prev_value = "";
    	$prev_date = "";
    
	    for ( $i=0; $i<count($rows); $i++ ) {
	      $row = $rows[$i];
	
		  $sep = "";
	      $srow = "";
	      foreach ($hkeys as $fn) {
	        $v = $row[$fn];
	        $v = str_replace('"','""',$v);

	        if ($fn == 'date') { $v = @$dates[$row[$fn]]; }
	        if (($fn == 'user') && ($v == '') && ($sort_key == 'user')) $v = $row['sortkey'];
			if ($fn == 'project') {
				if (($v == '') && ($sort_key == 'project')) $v = $row['sortkey'];
			}
			if ($fn == 'activity') {
				if (($v == '') && ($sort_key == 'activity')) $v = $row['sortkey'];
			}
			if ($bean->getAttribute('showidle')) {
				if (($fn == 'note') && ($v == '') && (strlen($row['duration']) == 0)) $v = "no data";
				if (($fn == 'project') && ($v == '') && $bean->getAttribute('project')) $v = $current_project_name;
				if (($fn == 'activity') && ($v == '') && $bean->getAttribute('activity')) $v = $current_task_name;
			}
			
			if(defined('EXPORT_DECIMAL_DURATION') && isTrue(EXPORT_DECIMAL_DURATION) && ($fn == 'duration') && $v)
				$v = time_to_decimal($v);
				
			$v = '"'.$v.'"';
			$srow .= $sep . $v;
	        $sep = ",";
		  }
		  print "$srow\n";
		  //--
		  
		  $prev_value = $row['sortkey'];
		  $prev_date = $row['date'];
		}
	}

?>